/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package es.rickyepoderi.compiler;

import org.eclipse.jdt.internal.compiler.ClassFile;

/**
 * Custom class loader that let us insert the resulting compilation classes
 * into it. This way a Class could be get after compilation.
 * 
 * @author ricky
 */
public class CustomClassLoader extends ClassLoader {

    /**
     * The custom class loader always has the class loader used in the
     * compilation as its parent class loader.
     * @param parent The parent class loader.
     */
    public CustomClassLoader(ClassLoader parent) {
        super(parent);
    }

    /**
     * Empty constructor.
     */
    public CustomClassLoader() {
        super();
    }
    
    /**
     * Method that loads the classFiles as classes inside the class loader.
     * @param classFiles The compiled classes obtained after compilation
     */
    public void loadThisClass(ClassFile[] classFiles) {
        for (ClassFile classFile : classFiles) {
            char[][] compoundName = classFile.getCompoundName();
            StringBuilder className = new StringBuilder();
            String sep = "";
            for (char[] compoundName1 : compoundName) {
                className.append(sep);
                className.append(new String(compoundName1));
                sep = ".";
            }
            byte[] bytes = classFile.getBytes();
            resolveClass(defineClass(className.toString(), bytes, 0, bytes.length));
        }
    }
}

