/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package es.rickyepoderi.compiler;

import java.lang.reflect.Method;
import java.util.HashMap;
import java.util.Locale;
import java.util.Map;
import org.eclipse.jdt.internal.compiler.DefaultErrorHandlingPolicies;
import org.eclipse.jdt.internal.compiler.IErrorHandlingPolicy;
import org.eclipse.jdt.internal.compiler.IProblemFactory;
import org.eclipse.jdt.internal.compiler.env.ICompilationUnit;
import org.eclipse.jdt.internal.compiler.env.INameEnvironment;
import org.eclipse.jdt.internal.compiler.impl.CompilerOptions;
import org.eclipse.jdt.internal.compiler.problem.DefaultProblemFactory;
import org.eclipse.jdt.internal.compiler.Compiler;

/**
 *
 * @author ricky
 */
public class Test {
    
    static public void main(String[] args) throws Exception {
        // define class name and source
        String className = "example.HelloWorld";
        String source
                =  "package example;"
                + "import java.util.*;\n"
                + "public class HelloWorld {\n"
                + "  static public class Internal {\n"
                + "    public Object sayHello() {\n"
                + "      return \"Hello!\";"
                + "    }\n"
                + "  }\n"
                + "  public static void sayHello() {\n"
                + "    System.out.println(new Internal().sayHello());\n"
                + "  }\n"
                + "}\n";
        // create the environment
        ClassLoader cl = Thread.currentThread().getContextClassLoader();
        INameEnvironment env = new CompilerEnvironment(cl, className, source.toCharArray());
        // policy
        IErrorHandlingPolicy policy = DefaultErrorHandlingPolicies.proceedWithAllProblems();
        // options
        Map<String,String> settings = new HashMap<>();
        settings.put(CompilerOptions.OPTION_LineNumberAttribute, CompilerOptions.GENERATE);
        settings.put(CompilerOptions.OPTION_SourceFileAttribute, CompilerOptions.GENERATE);
        settings.put(CompilerOptions.OPTION_ReportDeprecation, CompilerOptions.IGNORE);
        settings.put(CompilerOptions.OPTION_Encoding, "UTF-8");
        settings.put(CompilerOptions.OPTION_Source, "1.7");
        settings.put(CompilerOptions.OPTION_TargetPlatform, "1.7");
        settings.put(CompilerOptions.OPTION_Compliance, "1.7");
        CompilerOptions options = new CompilerOptions(settings);
        // requestor
        CompilerRequestor requestor = new CompilerRequestor(className, cl);
        // problem factory
        IProblemFactory problemFactory = new DefaultProblemFactory(Locale.getDefault());
        ICompilationUnit[] compilationUnits = new ICompilationUnit[1];
        compilationUnits[0] = new CompilationUnit(className, source.toCharArray());
        // compile
        Compiler compiler = new Compiler(env, policy, options, requestor, problemFactory);
        compiler.compile(compilationUnits);
        if (!requestor.isSuccess()) {
            throw new Exception(requestor.getErrors());
        }
        // execute the static method
        Class clazz = requestor.getResultClass();
        Method method = clazz.getMethod("sayHello");
        method.invoke(null);
    }
}
