/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package es.rickyepoderi.compiler.jsp;

import es.rickyepoderi.compiler.DefaultCompilerOptions;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.net.URL;
import javax.servlet.http.HttpServlet;
import javax.servlet.jsp.JspFactory;
import org.apache.jasper.JasperException;
import org.apache.jasper.JspCompilationContext;
import org.apache.jasper.compiler.Compiler;
import org.apache.jasper.compiler.JspConfig;
import org.apache.jasper.compiler.JspRuntimeContext;
import org.apache.jasper.compiler.TagPluginManager;
import org.apache.jasper.compiler.TldCache;
import org.apache.jasper.runtime.JspFactoryImpl;
import org.apache.jasper.servlet.JspCServletContext;
import org.apache.jasper.servlet.TldScanner;
import org.xml.sax.SAXException;

/**
 *
 * @author ricky
 */
public class Test {

    private JspCServletContext context;
    private JspRuntimeContext rctxt;
    private final String uriRoot = "/home/ricky/NetBeansProjects/CompileTest/web/";
    private String jspSource = null;
    private DefaultCompilerOptions opts = null;

    public Test(String jspSource) {
        this.jspSource = jspSource;
    }
    
    //
    // REST
    //
    
    protected void initServletContext(ClassLoader classLoader)
            throws IOException, JasperException {
        PrintWriter log = new PrintWriter(System.out);
        URL resourceBase = new File(this.uriRoot).getCanonicalFile().toURI().toURL();
        this.context = new JspCServletContext(log, resourceBase, classLoader, true, true);
        this.context.setInitParameter("org.apache.jasper.XML_VALIDATE_TLD", "true");
        TldScanner scanner = new TldScanner(this.context, true, true, true);
        scanner.setClassLoader(classLoader);
        try {
            scanner.scan();
        } catch (SAXException e) {
            throw new JasperException(e);
        }
        opts = new DefaultCompilerOptions();
        opts.setJspConfig(new JspConfig(this.context));
        opts.setTagPluginManager(new TagPluginManager(this.context));
        opts.setTldCache(new TldCache(this.context, scanner.getUriTldResourcePathMap(), scanner.getTldResourcePathTaglibXmlMap()));
        this.context.setAttribute(TldCache.SERVLET_CONTEXT_ATTRIBUTE_NAME, opts.getTldCache());
        this.rctxt = new JspRuntimeContext(this.context, opts);
    }

    protected void processFile(String jspUri) throws JasperException {
        //ClassLoader originalClassLoader = null;
        try {
            JspCompilationContext clctxt = new MemoryJspCompilationContext(jspUri, jspSource, opts, this.context, null, this.rctxt);
            Compiler clc = clctxt.createCompiler();
            clc.compile(true, true);
            
            Class clazz = ((MemoryCompiler) clc).getGeneratedClass();
            
            HttpServlet servlet = (HttpServlet) clazz.newInstance();
            
            System.err.println(servlet);
        } catch (Exception e) {
            throw new JasperException(e);
        }
    }

    
    static private String readFile(String file) throws IOException {
        BufferedReader reader = new BufferedReader(new FileReader(file));
        String line = null;
        StringBuilder stringBuilder = new StringBuilder();
        String ls = System.getProperty("line.separator");
        while ((line = reader.readLine()) != null) {
            stringBuilder.append(line);
            stringBuilder.append(ls);
        }
        return stringBuilder.toString();
    }
    
    static public void main(String[] args) throws Exception {
        JspFactory.setDefaultFactory(new JspFactoryImpl());
        Test test = new Test(readFile("/home/ricky/NetBeansProjects/CompileTest/src/java/es/rickyepoderi/samples/jsp/customtag.jsp"));
        test.initServletContext(Thread.currentThread().getContextClassLoader());
        test.processFile("/samplejstl.jsp");
    }


}
