/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package es.rickyepoderi.jsf;

import java.io.IOException;
import java.io.InputStream;
import java.net.URL;
import java.net.URLConnection;

/**
 * <p>Fake class to represent a MemoryURLConnection. This class
 * is created with the url and the InputStream of the resource. 
 * For more information of URL integration see:
 * http://docstore.mik.ua/orelly/java/exp/ch09_06.htm
 * </p>
 * 
 * @author ricky
 */
public class MemoryURLConnection extends URLConnection {

    /**
     * The input stream of the resource.
     */
    private InputStream in = null;
    
    /**
     * The constructor receives the URL and the resource itself.
     * @param url The url 
     * @param in The input stream of the resource
     * @throws IOException Some error
     */
    public MemoryURLConnection(URL url, InputStream in) throws IOException {
        super(url);
        this.in = in;
    }
    
    /**
     * Nothing because the resource is already there.
     * @throws IOException Some error
     */
    @Override
    public void connect() throws IOException {
        this.connected = true;
    }
    
    /**
     * It just returns the input stream already passed.
     * @return The input stream of the resource
     * @throws IOException Some error
     */
    @Override
    public InputStream getInputStream() throws IOException { 
        if (!connected) {
            connect(); 
        }
        return in; 
    } 

    /**
     * The content type is fixed to "application/xhtml+xml" template.
     * @return The content type
     */
    @Override
    public String getContentType() {
        return "application/xhtml+xml";
    }
    
}
