/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package sun.net.www.protocol.mem;

import es.rickyepoderi.jsf.MemoryURLConnection;
import java.io.IOException;
import java.io.InputStream;
import java.net.URL;
import java.net.URLConnection;
import java.net.URLStreamHandler;
import javax.faces.context.FacesContext;
import javax.servlet.ServletContext;

/**
 * <p>Class to open a memory URL. As it was explained in the MemoryResourceHandler
 * the <em>mem://</em> protocol just locates the resource from the context of
 * the application, under directory <em>/WEB-INF/classes/es/rickyepoderi/samples/facelets</em>.
 * This class should be called <em>sun.net.www.protocol.mem</em> as specified
 * in the URL Java behavior.</p>
 * 
 * @author ricky
 */
public class Handler extends URLStreamHandler {

    /**
     * Method that locates the resource under the context (packages inside the
     * WAR file).
     * @param url The memory URL
     * @return A new MemoryURLConnection with the resource
     * @throws IOException some error
     */
    @Override
    protected URLConnection openConnection(URL url) throws IOException {
        ServletContext servletContext = (ServletContext) FacesContext.getCurrentInstance().getExternalContext().getContext();
        InputStream in = servletContext.getResourceAsStream("/WEB-INF/classes/es/rickyepoderi/samples/facelets" + url.getPath());
        if (in != null) {
            return new MemoryURLConnection(url, in);
        } else {
            return null;
        }
    }
    
}
